<template>
  <v-container>
    <v-table height="500px">
      <thead>
        <tr>
          <th class="text-left">id</th>
          <th class="text-left">Make</th>
          <th class="text-left">Model</th>
          <th class="text-left">Fule Type</th>
          <th class="text-left">Price Per Day</th>
          <th class="text-left">Action</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="vehicle in vehicles" :key="vehicle.registrationNumber">
          <td>{{ vehicle.registrationNumber }}</td>
          <td>{{ vehicle.make }}</td>
          <td>{{ vehicle.model }}</td>
          <td>{{ vehicle.fuelType }}</td>
          <td>{{ vehicle.pricePerDay }}</td>
          <td>
            <v-btn @click="selectVehicle(vehicle)" flat color="secondary"
              >Book</v-btn
            >
          </td>
        </tr>
      </tbody>
    </v-table>
    <v-dialog v-model="dialog">
      <v-card>
        <v-card-title> Pick booking dates </v-card-title>
        <v-card-text>
          <v-row>
            <v-col>
              <v-text-field
                v-model="startDate"
                :min="Date()"
                label="Start Date"
                type="date"
                required
              ></v-text-field>
            </v-col>
            <v-col>
              <v-text-field
                v-model="endDate"
                label="End Date"
                type="date"
                required
              ></v-text-field>
            </v-col>
          </v-row>
        </v-card-text>
        <v-card-actions>
          <v-btn color="primary" @click="book()">Confirm</v-btn>
          <v-btn color="error" @click="dialog = false">Cancel</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script lang="ts">
import type { Ref } from "vue";
import { defineComponent, ref } from "vue";

import { useVehicleStore } from "@/stores/vehicles";
import type { Vehicle } from "@/ts/types";
import { useBookedStore } from "@/stores/booked";

export default defineComponent({
  setup() {
    const dialog: Ref<boolean> = ref(false);
    const startDate: Ref<string | undefined> = ref();
    const endDate: Ref<string | undefined> = ref();

    const selectedVehicle: Ref<Vehicle | undefined> = ref();

    const vehicleStrore = useVehicleStore();

    const vehicles: Ref<Array<Vehicle> | undefined> = ref(
      vehicleStrore.getAllVehicles
    );

    const selectVehicle = (vehicle: Vehicle) => {
      dialog.value = true;
      selectedVehicle.value = vehicle;
    };

    const book = () => {
      useBookedStore().book(
        selectedVehicle.value,
        startDate.value,
        endDate.value
      );
      dialog.value = false;
    };
    return { vehicles, startDate, endDate, book, dialog, selectVehicle };
  },
});
</script>
